#pragma semicolon 1

#define PLUGIN_AUTHOR "MrQout"
#define PLUGIN_VERSION "1.1.2"

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <csgo_colors>
#include <shop>

#pragma newdecls required

Handle kv;
char SND_CRAFT[PLATFORM_MAX_PATH] = "snd_craft.wav";
float SND_Volume = 1.0;

public Plugin myinfo = 
{
	name = "System Craft",
	author = PLUGIN_AUTHOR,
	description = "Craft items",
	version = PLUGIN_VERSION,
	url = "hlmod.ru"
};

public void OnPluginStart()
{
	RegAdminCmd("sm_craft_reload", Command_Reload, ADMFLAG_CONFIG, "Reload Config");
	RegAdminCmd("sm_crafts_reload", Command_Reload, ADMFLAG_CONFIG, "Reload Config");
	RegConsoleCmd("sm_craft" , Command_Craft, "Show main menu");
	RegConsoleCmd("sm_crafts", Command_Craft, "Show main menu");
	
	if (Shop_IsStarted()) Shop_Started();
}

public void OnPluginEnd()
{
	Shop_UnregisterMe();
}

public void Shop_Started()
{
	Command_Reload(0, 0);
	Shop_AddToFunctionsMenu(FunctionDisplay, FunctionSelect);
}

public void OnMapStart()
{
	Downloads();
}

public void Downloads()
{
	char SNDFile[PLATFORM_MAX_PATH];
	FormatEx(SNDFile, sizeof(SNDFile), "sound/%s", SND_CRAFT);
	
	if(strlen(SND_CRAFT) > 0 && FileExists(SNDFile))
	{
		AddFileToDownloadsTable(SNDFile);
		
		FormatEx(SNDFile, sizeof(SNDFile), "*%s", SND_CRAFT);
		SND_CRAFT = SNDFile;
		PrecacheSound(SNDFile, true);
	}
}

public Action Command_Reload(int client, int args)
{
	char _buffer[PLATFORM_MAX_PATH];
	Shop_GetCfgFile(_buffer, sizeof(_buffer), "Crafts.txt");
	
	if (kv != INVALID_HANDLE) CloseHandle(kv);
	kv = CreateKeyValues("Craft");
	
	if (!FileToKeyValues(kv, _buffer)) ThrowError("\"%s\" not parsed", _buffer);
	else
	{
		KvRewind(kv);
		
		KvGetString(kv, "sound_file", SND_CRAFT, sizeof(SND_CRAFT), SND_CRAFT);
		SND_Volume = KvGetFloat(kv, "sound_volume", 1.0);
		
		KvRewind(kv);
	}
	
	if (client > 0)
		PrintToConsole(client, "The configuration has been successfully reloaded");
}

public Action Command_Craft(int client, int args)
{	
	if (IsValidClient(client)) ShowMenu_Main(client);
	
	return Plugin_Handled;
}

public bool CheckValue(char[] str)
{
	return (str[strlen(str)-1] == ')');
}

stock char[] substr(char[] inpstr, int startpos, int len=-1)
{
    char outstr[64];

    if (len == -1)
    	strcopy(outstr, sizeof(outstr), inpstr[startpos]);
    else
    {
        strcopy(outstr, len, inpstr[startpos]);
        outstr[len] = 0;
    }

    return outstr; 
}

public void HandlerSelect(int client, char Name[64])
{
	KvRewind(kv);
	if (KvJumpToKey(kv, Name, false))
	{
		char ItemName[64], Items[4096], ItemsArray[32][64], GetGiveItemName[64], GetGiveCategoryName[64];
		
		KvGetString(kv, "name", ItemName, sizeof(ItemName), "");

		if (ItemName[0] != '\0')
		{
			KvGetString(kv, "items", Items, sizeof(Items), "");
			if (Items[0] != '\0')
			{
				ExplodeString(Items, ",", ItemsArray, 32, 64);
				
				for (int i = 0; i < sizeof(ItemsArray); i++)
				{
					if (ItemsArray[i][0] == '\0')continue;
					
					char Split[2][64], Split2[2][64];
					
					ExplodeString(ItemsArray[i][0], ":", Split, 2, 64);
					
					int nValue = 1;
					if (CheckValue(Split[1]))
					{
						ExplodeString(Split[1], "(", Split2, 2, 8);
						nValue = (Split2[1][0] == '\0' ? 1 : StringToInt(substr(Split2[1], 0, strlen(Split2[1]))));
						
						Split[1] = Split2[0];
					}
					
					
					RemovePlayerItem2(client, Split[0], Split[1], nValue);
				}
				
				Items = "";
				for (int i = 0; i < sizeof(ItemsArray); i++)ItemsArray[i] = "";
				
				int chance = KvGetNum(kv, "chance", -1);
				
				if (SND_CRAFT[0] != '\0' && SND_Volume > 0.0)
					EmitSoundToClient(client, SND_CRAFT, _, _, _, _, SND_Volume);
				
				if (chance <= 0 || (GetRandomInt(0, chance) == GetRandomInt(0, chance)))
				{
					KvGetString(kv, "give_items", Items, sizeof(Items), "");
					if (Items[0] != '\0')
					{
						ExplodeString(Items, ",", ItemsArray, 32, 64);
						int count = 0;
						
						for (int i = 0; i < sizeof(ItemsArray); i++)
						{
							if (ItemsArray[i][0] == '\0')continue;
							
							char Split[2][64], Split2[2][64];
							
							ExplodeString(ItemsArray[i][0], ":", Split, 2, 64);
							
							int nValue = 1;
							if (CheckValue(Split[1]))
							{
								ExplodeString(Split[1], "(", Split2, 2, 8);
								
								nValue = (Split2[1][0] == '\0' ? 1 : StringToInt(substr(Split2[1], 0, strlen(Split2[1]))));
								Split[1] = Split2[0];
							}
								
							Shop_GetCategoryNameById(Shop_GetCategoryId(Split[0]), GetGiveCategoryName, sizeof(GetGiveCategoryName));
							Shop_GetItemNameById(GivePlayerItem2(client, Split[0], Split[1], nValue), GetGiveItemName, sizeof(GetGiveItemName));
							
							count++;
						}
						
						char Msg[128];
						
						if (count == 1)
							Format(Msg, sizeof(Msg), "вещь \"{green}%s{default}\" в категорию \"{green}%s{default}\".", GetGiveItemName, GetGiveCategoryName);
						else if (count > 1)
							Format(Msg, sizeof(Msg), "%i вещи(-ей)", count);
						
						CGOPrintToChat(client, " {red}[Craft] {default}Вы использовали крафт \"{green}%s{default}\" и получаете", ItemName);
						CGOPrintToChat(client, " %s", Msg);
					}
				}
				else
					CGOPrintToChat(client, " {red}[Craft] {default}Неудачный крафт");
			}
		}
	}
	KvRewind(kv);
}

public int Main_MenuHandler(Menu menu, MenuAction action, int client, int param)
{
	if (action == MenuAction_End)
	{
		delete menu;
	}
	else if (action == MenuAction_Cancel && param == MenuCancel_ExitBack)
	{
		Shop_ShowFunctionsMenu(client);
	}
	else if (action == MenuAction_Select)
	{		
		char szInfo[64], szTitle[64];
		menu.GetItem(param, szInfo, sizeof(szInfo), _, szTitle, sizeof(szTitle));
		
		ShowMenu_SelectCraft(client, szInfo, szTitle);
	}
}

public int Main_MenuHandler2(Menu menu, MenuAction action, int client, int param)
{
	if (action == MenuAction_End)
	{
		delete menu;
	}
	else if (action == MenuAction_Cancel && param == MenuCancel_ExitBack)
	{
		ShowMenu_Main(client);
	}
	else if (action == MenuAction_Select)
	{
		char Name[64];
		menu.GetItem(param, Name, sizeof(Name));
		
		HandlerSelect(client, Name);
	}
}

void ShowMenu_SelectCraft(int client, char[] name, char[] title)
{
	KvRewind(kv);
	if (KvJumpToKey(kv, name, false))
	{
		bool IsItem = false, AccessCraft = true;
		char ItemInfo[256], Items[4096], ItemsArray[32][64];
		KvGetString(kv, "give_items", Items, sizeof(Items), "");
		if (Items[0] != '\0')
		{
			ExplodeString(Items, ",", ItemsArray, 32, 64);
			
			for (int i = 0; i < sizeof(ItemsArray); i++)
			{
				if (ItemsArray[i][0] == '\0')continue;
				
				char Split[2][64], Split2[2][64];
				
				ExplodeString(ItemsArray[i][0], ":", Split, 2, 64);
				
				int nValue = -1;
				if (CheckValue(Split[1]))
				{
					ExplodeString(Split[1], "(", Split2, 2, 8);
					
					nValue = (Split2[1][0] == '\0' ? 1 : StringToInt(substr(Split2[1], 0, strlen(Split2[1]))));
					Split[1] = Split2[0];
				}
				
				AccessCraft = !IsPlayerItem2(client, Split[0], Split[1], nValue);
				IsItem = !AccessCraft;
				
				if (AccessCraft)break;
			}

			// Clear
			Items = "";
			for (int i = 0; i < sizeof(ItemsArray); i++)ItemsArray[i] = "";
			
			KvGetString(kv, "items", Items, sizeof(Items), "");
			if (Items[0] != '\0')
			{
				ExplodeString(Items, ",", ItemsArray, 32, 64);
				for (int i = 0; i < sizeof(ItemsArray); i++)
				{
					if (ItemsArray[i][0] == '\0')continue;
					
					char Split[2][64], Split2[2][64], CategoryName[64], ItemName[64];
					
					ExplodeString(ItemsArray[i][0], ":", Split, 2, 64);
					
					int nValue = -1;
					if (CheckValue(Split[1]))
					{
						ExplodeString(Split[1], "(", Split2, 2, 8);
						
						nValue = (Split2[1][0] == '\0' ? 1 : StringToInt(substr(Split2[1], 0, strlen(Split2[1]))));
						Split[1] = Split2[0];
					}
					
					CategoryId CId = Shop_GetCategoryId(Split[0]);
					Shop_GetCategoryNameById(CId, CategoryName, sizeof(CategoryName));
					Shop_GetItemNameById(Shop_GetItemId(CId, Split[1]), ItemName, sizeof(ItemName));
					
					if (nValue == -1)
						Format(ItemInfo, sizeof(ItemInfo), "%s[%s] %s\n", ItemInfo, CategoryName, ItemName);
					else
						Format(ItemInfo, sizeof(ItemInfo), "%s[%s] %s (%i)\n", ItemInfo, CategoryName, ItemName, nValue);
					
					AccessCraft = (AccessCraft && IsPlayerItem2(client, Split[0], Split[1], nValue));
				}
			}
			
			Format(ItemInfo, sizeof(ItemInfo), "%s\n \n--- Требуется ---\n%s\n \n ", title, ItemInfo);
			
			Menu menu = new Menu(Main_MenuHandler2);
			menu.SetTitle(ItemInfo);
			
			
			char BtnName[32];
			Format(BtnName, sizeof(BtnName), "%s", (IsItem ? "Уже имеется" : "Скрафтить"));
			
			menu.AddItem(name, BtnName, (!AccessCraft ? ITEMDRAW_DISABLED : ITEMDRAW_DEFAULT));
			
			menu.ExitBackButton = true;
			menu.Display(client, MENU_TIME_FOREVER);
		}
	}
	KvRewind(kv);
}

void ShowMenu_Main(int client)
{
	Menu menu = new Menu(Main_MenuHandler);
	menu.SetTitle("Крафты");
	
	KvRewind(kv);
	
	bool HideItem = false;
	HideItem = (KvGetNum(kv, "hide_noaccess", 0) == 1 ? true : false);
	
	if (KvGotoFirstSubKey(kv))
	{
		do
		{
			bool AccessCraft = true;
			char SectionName[64], Name[64], Items[4096], ItemsArray[32][64];
			
			if (!KvGetSectionName(kv, SectionName, sizeof(SectionName))
				|| SectionName[0] == '\0')continue;
			
			KvGetString(kv, "name", Name, sizeof(Name), "");
			if (Name[0] == '\0')continue;

			KvGetString(kv, "items", Items, sizeof(Items), "");
			if (Items[0] == '\0')continue;
			
			ExplodeString(Items, ",", ItemsArray, 32, 64);
			
			for (int i = 0; i < sizeof(ItemsArray); i++)
			{
				if (ItemsArray[i][0] == '\0')continue;
				
				char Split[2][64], Split2[2][64];
				
				ExplodeString(ItemsArray[i][0], ":", Split, 2, 64);
				
				int nValue = 1;
				if (CheckValue(Split[1]))
				{
					ExplodeString(Split[1], "(", Split2, 2, 8);
					nValue = (Split2[1][0] == '\0' ? 1 : StringToInt(substr(Split2[1], 0, strlen(Split2[1]))));
					
					Split[1] = Split2[0];
				}
				
				AccessCraft = (AccessCraft && IsPlayerItem2(client, Split[0], Split[1], nValue));
			}
			
			if (!HideItem || AccessCraft) menu.AddItem(SectionName, Name, ITEMDRAW_DEFAULT);
		}
		while (KvGotoNextKey(kv));
	}
	
	KvRewind(kv);
	
	menu.ExitBackButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public bool FunctionSelect(int client)
{
	ShowMenu_Main(client);
	return true;
}

public void FunctionDisplay(int client, char[] buffer, int maxlength)
{
	strcopy(buffer, maxlength, "Крафт");
}

ItemId GivePlayerItem2(int iClient, const char[] CategoryName, const char[] ItemName, int value = -1)
{
	ItemId item_id = Shop_GetItemId(Shop_GetCategoryId(CategoryName), ItemName);
	Shop_GiveClientItem(iClient, item_id);
	
	if (value > 1)Shop_SetClientItemCount(iClient, item_id, value);
	
	return item_id;
}

public ItemId RemovePlayerItem2(int iClient, const char[] CategoryName, const char[] ItemName, int value)
{
	ItemId item_id = Shop_GetItemId(Shop_GetCategoryId(CategoryName), ItemName);
	Shop_ToggleClientItem(iClient, item_id, Toggle_Off);
	Shop_RemoveClientItem(iClient, item_id, value);
	
	return item_id;
}

bool IsPlayerItem2(int iClient, const char[] CategoryName, const char[] ItemName, int value = -1)
{
	ItemId _ItemId = Shop_GetItemId(Shop_GetCategoryId(CategoryName), ItemName);
	if (Shop_IsClientHasItem(iClient, _ItemId) && (value == -1 || Shop_GetClientItemCount(iClient, _ItemId) >= value))
		return true;
		
	return false;
}

public bool IsValidClient(int client)
{
	return client > 0 ? IsClientInGame(client) && !IsFakeClient(client) ? true : false : false;
}